/*
 * gimmix-arith.h -- University of Applied Sciences Giessen
 *                   MMIX-ARITH implementation
 */


#ifndef _GIMMIX_ARITH_H_
#define _GIMMIX_ARITH_H_


#include "gimmix-common.h"


#define sign_bit		((unsigned) 0x80000000)


extern octa zero_octa;			/* 0 */
extern octa neg_one;			/* -1 */
extern octa inf_octa;			/* floating point +infinity */
extern octa standard_NaN;		/* floating point NaN(.5) */


octa oplus(octa y, octa z);		/* unsigned y + z */
octa ominus(octa y, octa z);		/* unsigned y - z */
octa incr(octa y, int delta);		/* unsigned y + delta (signed) */
octa shift_left(octa y, int s);		/* y << s, 0 <= s <= 64 */
octa shift_right(octa y, int s, int u);	/* y >> s, signed if !u */
octa omult(octa y, octa z);		/* unsigned (aux,x) = y * z */
octa signed_omult(octa y, octa z);	/* signed x = y * z */
octa odiv(octa x, octa y, octa z);	/* unsigned (x,y) / z, aux = mod z */
octa signed_odiv(octa y, octa z);	/* signed x = y / z */
octa oand(octa y, octa z);		/* y AND z */
octa oandn(octa y, octa z);		/* */
octa oxor(octa y, octa z);		/* */
int count_bits(tetra x);		/* */
tetra byte_diff(tetra y, tetra z);	/* */
tetra wyde_diff(tetra y, tetra z);	/* */
octa bool_mult(octa y, octa z, bool xor);	/* MOR or MXOR */


#endif /* _GIMMIX_ARITH_H_ */
